// import {extract} from "./Utilities.js";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class Google_Images {
    constructor(_query) {
        this._query = _query;
        // => this._query = _query; -> no need!
        this._item_data = new Promise((ready, problem) => {
            this._get_Google_Images(ready, problem);
        });
    }
    static Get_instance(query) {
        let gi = Google_Images._All.find((element) => {
            return element._query === query;
        });
        if (gi === undefined) {
            gi = new Google_Images(query);
            Google_Images._All.push(gi);
        }
        return gi;
    }
    ;
            // An 'async' function always returns a 'Promise' object (https://blog.bitsrc.io/keep-your-promises-in-typescript-using-async-await-7bdc57041308).
            // The 'Promise' object resolves by construction to the returned value:
            get_Google_Images() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this._item_data; // Wait for '_get_item_data' (i.e., 'ready(offi);')
        });
    }
    _get_Google_Images(ready, problem, time_out) {
        // https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API/Using_Fetch
        fetch(`${Google_Images._URL}${Google_Images._Path}${this._query}`).then(function (response) {
            response.text().then(function (html) {
                console.log('HTML: ' + html);
                console.log(html.match(Google_Images._S_tag));
                // Split on 'this._query': "CASSOULET GRAND JURY SUPERIEUR BOITE 4/4"
                html.split(this._query).forEach((html_piece) => {
                    // if (Google_Images._RH_tag.test(html_piece)) { // Filtre sur URL des sites...
                    const image_URLs = html_piece.match(Google_Images._Image_URL_pattern);
                    if (image_URLs !== null) {
                        image_URLs.forEach((image_URL) => {
                            image_URL = image_URL.substring(1, image_URL.length - 1);
                            console.log('image_URL: ' + image_URL);
                        });
                    }
                    // }
                });
            }.bind(this))
                    .catch((error) => {
                        problem();
                        window.alert('Error response.json().then: ' + error.message);
                    });
        }.bind(this))
                .catch((error) => {
                    //problem();
                    window.alert('Error ' + `${Google_Images._URL}${Google_Images._Path}${this._query}: ` + error.name);
                });
    }
}
Google_Images._All = new Array();
// dia, picard, système U,
Google_Images._RH_tag = /"rh":"(amazon\.fr|auchandirect\.fr|bienmanger\.com|carrefour\.fr|catalogue\.cerclevert\.fr|chronodrive\.com|cdiscount\.com|danival\.fr|e-leclerc\.com|episaveurs\.fr|etiketbio\.eu|geantcasino\.fr|intermarche\.com|lagrandeepicerie\.com|lesrobinsdesbio\.com|leaderprice\.fr|lidl\.fr|mangerbiochezmoi\.com|monoprix\.fr|promobutler\.be|provincesbio\.com|prixing\.fr|shoptimise\.fr|webecologie\.com)"/gi;
Google_Images._PT_tag = /"pt":"[^"]*/g;
Google_Images._S_tag = /"s":"[^"]*/g;
// 'g' means all occurrences while 'i' means case-insensitive:
Google_Images._Image_URL_pattern = /"(http(s?):)([/|.|\w|\s|-])*\.(?:gif|jpeg|jpg|png)("|\?)/gi;
Google_Images._Path = '/search?tbm=isch&q=';
// private static readonly _Pattern: RegExp = /https:\/\/encrypted\-tbn0\.gstatic\.com/g;
Google_Images._URL = 'https://cors-anywhere.herokuapp.com/https://www.google.com';
