package com.FranckBarbier.Java.Carrefour_Items;

/**
 * Run this app. with '-ea' option for catching failing assertions
 */
// Java data message:
class Search_result { // Id.: '_gtin' && '_word'

    private final String _gtin;
    private final int _strong;
    private final int _weak;
    private final String _word;
    final java.util.Set<String> _words = new java.util.HashSet<>();
    final String _image_URL;

    Search_result(javax.json.stream.JsonParser parser) {
        assert (parser.getString().equals(Carrefour_Items._GTIN)); // e.g., {"gtin":"3664346300162", "strong":0, "weak":0, "word":"noi", ...}
        assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_STRING); // '"3664346300162"'
        _gtin = parser.getString();
        assert (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME); // '"strong"'
        assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_NUMBER); // '0'
        _strong = parser.getInt();
        assert (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME); // '"weak"'
        assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_NUMBER); // '0'
        _weak = parser.getInt();
        assert (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME); // '"word"'
        assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_STRING); // "noi"
        _word = parser.getString();
        assert (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME); // '"product_name"'
        assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_STRING);
        // Split 'parser.getString()'?
        _words.add(Carrefour_Items.ToUpperCase(parser.getString()));
        assert (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME); // '"image_URL"'
        assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_STRING);
        _image_URL = parser.getString();
    }

    @Override
    public boolean equals(Object ci) {
        if (ci == this) {
            return true;
        }
        if (!(ci instanceof Search_result)) {
            return false;
        }
        return _gtin.equals(((Search_result) ci)._gtin) && _word.equals(((Search_result) ci)._word);
    }

    @Override
    public int hashCode() {
        return _gtin.hashCode() ^ _word.hashCode(); // Retourne 1 si l'un des deux bits de même poids est à 1 (mais pas les deux)
    }
}

public class Carrefour_Items {

//    https://github.com/apigee/trireme (Apigee)
    static void Node_js(String gtin) {
//        String[] command = {"which", "ls"}; // macOS-specific!
        String[] command = {"/usr/local/bin/node", "./Node.js/Carrefour_fr.Node.js", gtin}; // Default: macOS-specific!
        if (System.getProperty("os.name").contains("Windows")) {
            command[0] = "node"; // '\Program Files\nodejs\node.exe'
        }
        try {
            Process p = Runtime.getRuntime().exec(command);
            if (p.waitFor() == 0) { // Blocking! Better solution required, e.g., look at https://www.javaworld.com/article/2071275/when-runtime-exec---won-t.html
                try (java.io.BufferedReader input = new java.io.BufferedReader(new java.io.InputStreamReader(p.getInputStream()))) {
                    String content;
                    while ((content = input.readLine()) != null) {
                        System.out.println("Out: " + content);
                    }
                }
            } else {
                try (java.io.BufferedReader input = new java.io.BufferedReader(new java.io.InputStreamReader(p.getErrorStream()))) {
                    String content;
                    while ((content = input.readLine()) != null) {
                        System.err.println("Err: " + content);
                    }
                }
            }
        } catch (InterruptedException | java.io.IOException ieioe) {
            System.err.println("Runtime.getRuntime().exec(command): " + ieioe.getClass().getSimpleName() + ": " + ieioe.getMessage());
        }
    }
    /**
     * Carrefour Items API
     */
    private final static String _url = "https://api.fr.carrefour.io/v1/openapi/items";
// Création d'une app. et abonnement de l'app. à l'API Items de Carrefour ici : https://developer.fr.carrefour.io/content/items
// Etudiants :
    private final static String _X_ibm_client_id = "1e70cf82-6062-4067-8b6c-e5f34c0643b7";
    private final static String _X_ibm_client_secret = "eO8cF7qL5hX2wG0bT5hY6aV2kM7oE8aT2hT4iE8iP5aK3aT4pH";

    private final static String _ERROR = "error";
    private final static String _FOUND = "found";
    final static String _GTIN = "gtin";
    private final static String _LIST = "list";
    final static String _STRONG = "strong";
    final static String _WEAK = "weak";
    final static String _WORD = "word";
    /**
     * End of Carrefour Items API
     */

//    Delimited word: [^\w] <=> [^a-zA-Z_0-9]
    private final static java.util.regex.Pattern _Word = java.util.regex.Pattern.compile("[^\\w]");

    // Utility:
    static String ToUpperCase(String word) {
        return java.text.Normalizer.normalize(word, java.text.Normalizer.Form.NFD).replaceAll("\\p{M}", "").toUpperCase();
    }

    private final static java.util.Set<Carrefour_Items> _All = new java.util.HashSet<>();
    // Alternative with streams:
//    private final static java.util.stream.Stream.Builder<Carrefour_Items> _All_ = java.util.stream.Stream.builder();

    private final static java.util.concurrent.CompletableFuture<com.seekdasky.websocket.Client> _Bye = new java.util.concurrent.CompletableFuture<>();
    private final static java.util.concurrent.CompletableFuture<com.seekdasky.websocket.Client> _Handshaking = new java.util.concurrent.CompletableFuture<>();
    private final static StringBuffer _Raw_query = new StringBuffer();
    // https://stackoverflow.com/questions/6992608/why-there-is-no-concurrenthashset-against-concurrenthashmap
    private final static java.util.Set<Search_result> _Search_results = java.util.concurrent.ConcurrentHashMap.newKeySet();
    private final static com.seekdasky.websocket.WebSocketServer _WebSocketServer = com.seekdasky.websocket.WebSocketServer.getInstance();

    private static java.nio.file.WatchService _WatchService;

    static {
        Node_js("3560070478781");
        try {
            _WatchService = java.nio.file.FileSystems.getDefault().newWatchService(); // File system "Observer" pattern (from Java 7)
            /**
             * 'java.nio.file.Path' interface extends 'java.nio.file.Watchable'
             * interface
             */
            // 'database' directory is observed by a daemon for any file creation:
            java.nio.file.FileSystems.getDefault().getPath("Browser" + java.io.File.separatorChar + "database").register(_WatchService, java.nio.file.StandardWatchEventKinds.ENTRY_CREATE);
        } catch (java.io.IOException ioe) {
            java.util.logging.Logger.getLogger(Carrefour_Items.class.getSimpleName()).log(java.util.logging.Level.SEVERE, null, ioe);
            System.exit(1);
        }

//        _Handshaking.thenRun(() -> System.out.println("Handshaking"));
        assert (_WebSocketServer != null);
        _WebSocketServer.addListener(new com.seekdasky.websocket.WebSocketListener() {
            @Override
            public void processClosed(com.seekdasky.websocket.Event event) {
                _Bye.complete(event.getConnector());
            }

            @Override
            public void processEvent(com.seekdasky.websocket.Event event, com.seekdasky.websocket.Token token) {
//                System.out.println("Message from JavaScript: " + token.getRaw());
                try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(token.getRaw()))) {
                    while (parser.hasNext()) {
                        final javax.json.stream.JsonParser.Event next = parser.next();
                        if (next == javax.json.stream.JsonParser.Event.KEY_NAME) {
                            if (parser.getString().equals("Carrefour_Items")) {
                                assert (parser.next() == javax.json.stream.JsonParser.Event.VALUE_STRING);
                                String raw_query_element = parser.getString();
                                if (raw_query_element.equals("Handshaking")) {
                                    _Handshaking.complete(event.getConnector());
                                    _Raw_query.delete(0, _Raw_query.length());
                                    /**
                                     * Some data to initiate the process:
                                     */
                                    _All.add(new Carrefour_Items(Carrefour_Items_Query_Samples._Raw_POULA_NOISET, Carrefour_Items_Query_Samples._JSON_POULA_NOISET));
                                } else {
                                    if (raw_query_element.equals("Raw_query")) {
                                        System.out.print("Searching and querying: " + _Raw_query.toString());
                                        _All.add(new Carrefour_Items(_Raw_query.toString()));
                                        // Alternative with streams:
//                                        _All_.accept(new Carrefour_Items(_Raw_query.toString()));
                                    } else {
                                        // Each new input from JavaScript leads to some search in existing 'Carrefour_Items' objects:
                                        _Raw_query.replace(0, _Raw_query.toString().length(), raw_query_element);
                                        System.out.println("Searching: " + _Raw_query.toString());
                                        _All.forEach(ci -> ci.filter_items(_Raw_query.toString()));
                                    }
                                }
                            } else {
                                // 'interface Candidate_item' received from JavaScript:
                                System.out.println("-Validate- from JavaScript: " + token.getRaw());
                                Search_result sr = new Search_result(parser);
                                if (!_Search_results.add(sr)) { // Already in...
                                    // '_words' field requires update since id. relies on '_gtin' && '_word' only:
                                    _Search_results.stream().filter(element -> element.equals(sr)).findFirst().get()._words.addAll(sr._words);
                                }
                                if (!sr._image_URL.equals("")) {
                                    String image_file_name = sr._image_URL.replaceAll("[^a-zA-Z0-9_-]", "_");
                                    // https://www.baeldung.com/java-download-file
                                    try {
                                        // There is a priori no use of the app.'s memory with the concept of channel:
                                        java.nio.channels.ReadableByteChannel input = java.nio.channels.Channels.newChannel((new java.net.URL(sr._image_URL)).openStream());
                                        /**
                                         * TO DO: keep '.jpg', '.png' suffix at
                                         * end of file...
                                         */
                                        java.io.FileOutputStream output = new java.io.FileOutputStream("Browser" + java.io.File.separatorChar + "database" + java.io.File.separatorChar + image_file_name);
                                        output.getChannel().transferFrom(input, 0, Long.MAX_VALUE);
                                    } catch (java.net.MalformedURLException murle) {
                                        System.err.println(murle.getClass().getSimpleName() + ": " + murle.getMessage());
                                    } catch (java.io.IOException ioe) {
                                        System.err.println(ioe.getClass().getSimpleName() + ": " + ioe.getMessage());
                                    }
// Watch service waits for just created file in 'database':
                                    final java.util.concurrent.Callable<String> c = () -> { // Override 'call' method... 
                                        // 'take' is a blocking statement...
                                        java.nio.file.WatchEvent<?> we = _WatchService.take().pollEvents().get(0);
                                        return ((java.nio.file.WatchEvent<java.nio.file.Path>) we).context().toString(); // Return file name of just created file...
                                    };
// Task 'c' is executed as a thread to prevent blocking:
                                    java.util.concurrent.Future<String> f = java.util.concurrent.Executors.newSingleThreadExecutor().submit(c);
                                    try {
// TO DO: send (from now -local-) file name to JavaScript to be loaded as image and next transformed into texture for Three.js:                                       
                                        f.get();
                                    } catch (java.util.concurrent.ExecutionException | InterruptedException eeie) {
                                        java.util.logging.Logger.getLogger(Carrefour_Items.class.getSimpleName()).log(java.util.logging.Level.SEVERE, null, eeie);
                                        System.exit(3);
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
            }
        });
        _WebSocketServer.start();

        try {
            java.awt.Desktop.getDesktop().browse(java.nio.file.FileSystems.getDefault().getPath("Browser" + java.io.File.separatorChar + "index.html").toUri());
        } catch (java.io.IOException ioe) {
            java.util.logging.Logger.getLogger(Carrefour_Items.class.getSimpleName()).log(java.util.logging.Level.SEVERE, null, ioe);
            System.exit(2);
        }
    }

    private long _counted_items;

    public long get_counted_items() {
        return _counted_items;
    }
// Benchmarking (remove later on):
    private long _get_items_elapsed_time = 0L;
    private long _filter_items_elapsed_time = 0L;

    private String _json_query;
    private String _json_query_result;
    private final java.util.concurrent.CompletableFuture<Carrefour_Items> _json_query_result_promise = new java.util.concurrent.CompletableFuture<>();

    private final String _raw_query; // Id.

    @Override
    public boolean equals(Object ci) {
        if (ci == this) {
            return true;
        }
        if (!(ci instanceof Carrefour_Items)) {
            return false;
        }
        return _raw_query.equals(((Carrefour_Items) ci)._raw_query);
    }

    @Override
    public int hashCode() {
        return _raw_query.hashCode();
    }

    private Carrefour_Items(String raw_query) {
        assert (raw_query != null);
        _raw_query = ToUpperCase(raw_query);
        _build_query(); // '_json_query'
        _query();
    }

    private Carrefour_Items(String raw_query, String json_query) {
        assert (raw_query != null && json_query != null);
        _raw_query = ToUpperCase(raw_query);
        _json_query = json_query;
        _query();
    }

    private void _query() {
// This solution does not (directly) rely on handshaking, but 'filter_items_' internally uses '_Handshaking.get()':
        _json_query_result_promise.thenAccept((Carrefour_Items ci) -> {
            // Try to find words from raw query and then send results to JavaScript:
            if (_Raw_query.length() > 2) {
                System.out.println(" - filtering: " + _Raw_query.toString());
                ci.filter_items_(true, _Raw_query.toString()); // Parallel stream-based search
            }
        });
// FYI, only (this solution does not (directly) rely on handshaking as well):        
//        java.util.concurrent.CompletableFuture<String> cf = _json_query_result_promise.thenApply(new java.util.function.Function<Carrefour_Items, String>() {
//            @Override
//            public String apply(Carrefour_Items ci) {
//                // Same as 'thenAccept' with the possibility of returning something for chaining...
//                return ci._json_query_result;
//            }
//        });

        /**
         * Result is returned to JavaScript provided that handshaking *and*
         * (sequentially) 'get_items' properly resolved
         */
//        java.util.concurrent.CompletableFuture<Void> v = java.util.concurrent.CompletableFuture.allOf(_Handshaking, _json_query_result_promise);
//        v.thenAccept(new java.util.function.Consumer<Void>() {
//            @Override
//            public void accept(Void v) { // 'allOf' (strong) limitation
//                assert (v == null);
//                try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
//                    while (parser.hasNext()) {
//                        if (parser.next() == javax.json.stream.JsonParser.Event.START_OBJECT) {
//                            try {
//// Get handshaking data, so waiting for these data until available ('allOf' probably redundant):
//                                _WebSocketServer.sendToken(_Handshaking.get(), com.seekdasky.websocket.Token.buildFromJSON(parser.getObject()));
//                            } catch (java.util.concurrent.ExecutionException | InterruptedException | java.io.IOException ee_ie_ioe) {
//                                java.util.logging.Logger.getLogger(this.getClass().getSimpleName()).log(java.util.logging.Level.SEVERE, null, ee_ie_ioe);
//                            }
//                            break;
//                        }
//                    }
//                }
//            }
//        });
// 'allOf' (strong) limitations:
// https://medium.com/@senanayake.kalpa/fantastic-completablefuture-allof-and-how-to-handle-errors-27e8a97144a0
        this._get_items(java.time.Duration.ofSeconds(30L)); // '_json_query_result_promise.complete(this);'

//        System.out.println(this._get_items_elapsed_time + " ms - " + this.get_counted_items() + " returned items from " + this._json_query);
        System.out.println(this._json_query_result.length() / 10e6 + " MBytes of data...");
        System.out.println(_json_query_result);
    }

    private void _build_query() {
        // 'ToUpperCase(_raw_query)' is already done:
        // "Lessive Ariel dose vêtement deliça" -> "LESSIVE ARIEL DOSE VETEMENT DELICA"
        String[] words = _Word.split(_raw_query);

        // Query building strategy has to rely on '_Search_results', which is filled in by JavaScript
        javax.json.JsonArrayBuilder array_builder = javax.json.Json.createArrayBuilder();
        for (String word : words) {
            // No strategy yet:
            array_builder.add(javax.json.Json.createObjectBuilder()
                    .add("field", "barcodeDescription")
                    .add("query", word)
                    .build());
        }
        // No page management yet:
        _json_query = javax.json.Json.createObjectBuilder().add("size", 100)
                .add("queries", array_builder)
                .build()
                .toString();
    }

    private void _get_items(java.time.Duration time_out) {
        assert (!time_out.isNegative() && !time_out.isZero());
        if (_json_query != null && _json_query_result == null) {
            _get_items_elapsed_time = System.currentTimeMillis();
            javax.net.ssl.HttpsURLConnection connection = null;
            try {
                connection = (javax.net.ssl.HttpsURLConnection) (new java.net.URL(_url)).openConnection();
                connection.setRequestMethod("POST");
                connection.setConnectTimeout(((int) time_out.getSeconds()) * 1000); // In milliseconds!
                connection.setReadTimeout(((int) time_out.getSeconds()) * 1000); // In milliseconds!
                connection.setRequestProperty("accept", "application/json");
                connection.setRequestProperty("content-type", "application/json; charset=UTF-8");
                connection.setRequestProperty("x-ibm-client-id", _X_ibm_client_id);
                connection.setRequestProperty("x-ibm-client-secret", _X_ibm_client_secret);
//            System.out.println(connection.getRequestMethod()); // 'POST'
                connection.setDoOutput(true); // To have the possibility of setting up the body...
                java.io.OutputStreamWriter osw = new java.io.OutputStreamWriter(connection.getOutputStream());
                osw.write(_json_query);
//            osw.flush();
                osw.close(); // => 'flush'
// BUG (this does not work, the body is ill-formed):
//            java.io.OutputStream os = connection.getOutputStream();
//            os.write(java.net.URLEncoder.encode(body, "UTF-8").getBytes());
//            os.flush();
//            os.close();
// Query is launched:
                java.io.InputStream is = connection.getInputStream();
                _result_as_pretty_JSON(is); // Versus '_result_as_raw_JSON(is);'
// 'java.net.MalformedURLException' inherits from 'java.io.IOException' that prevents multi-catch, so:
            } catch (java.net.MalformedURLException murle) {
                _json_query_result = javax.json.Json.createObjectBuilder().add(_ERROR, murle.getMessage()).build().toString();
                System.err.println(murle.getClass().getSimpleName() + ": " + murle.getMessage());
            } catch (java.io.IOException ioe) {
                _json_query_result = javax.json.Json.createObjectBuilder().add(_ERROR, ioe.getMessage()).build().toString();
                System.err.println(ioe.getClass().getSimpleName() + ": " + ioe.getMessage());
            } finally {
                if (connection != null) {
                    connection.disconnect();
                }
                _json_query_result_promise.complete(this);
                _get_items_elapsed_time = System.currentTimeMillis() - _get_items_elapsed_time;
            }
        }
    }

    /**
     * This version is based on the OkHttp library. No significant difference
     * with 'get_items'
     */
    private void _get_items_(java.time.Duration time_out) { // OkHttp library: http://square.github.io/okhttp/
        assert (!time_out.isNegative() && !time_out.isZero());
        if (_json_query != null && _json_query_result == null) {
            _get_items_elapsed_time = System.currentTimeMillis();
            okhttp3.OkHttpClient.Builder builder = new okhttp3.OkHttpClient.Builder();
            builder.connectTimeout(time_out);
            builder.readTimeout(time_out);
            // builder.writeTimeout(time_out);
            okhttp3.OkHttpClient client = builder.build();

            okhttp3.Request request = new okhttp3.Request.Builder()
                    .url(_url) // ' private final static String _url = "https://api.fr.carrefour.io/v1/openapi/items";'
                    .post(okhttp3.RequestBody.create(okhttp3.MediaType.parse("application/json"), _json_query))
                    .addHeader("accept", "application/json")
                    .addHeader("content-type", "application/json")
                    .addHeader("x-ibm-client-id", _X_ibm_client_id)
                    .addHeader("x-ibm-client-secret", _X_ibm_client_secret)
                    .build();
            try (okhttp3.Response response = client.newCall(request).execute()) {
                java.io.InputStream is = response.body().source().inputStream();
                _result_as_pretty_JSON(is); // Versus '_result_as_raw_JSON(is);'
                // 'close' is guaranteed by try-with-resource(s)
            } catch (java.io.IOException ioe) {
                _json_query_result = javax.json.Json.createObjectBuilder().add(_ERROR, ioe.getMessage()).build().toString();
                System.err.println(ioe.getClass().getSimpleName() + ": " + ioe.getMessage());
            } finally {
                _json_query_result_promise.complete(this);
                _get_items_elapsed_time = System.currentTimeMillis() - _get_items_elapsed_time;
            }
        }
    }

    /**
     * This version is based on Java 11 asynchronous facilities
     */
//    private void _get_items__(java.time.Duration time_out) { // https://dzone.com/articles/java-11-standardized-http-client-api
//        assert (!time_out.isNegative() && !time_out.isZero());
//        if (_json_query != null && _json_query_result == null) {
//            _get_items_elapsed_time = System.currentTimeMillis();
//
//            var client = java.net.http.HttpClient.newBuilder().build();
//
//            var request = java.net.http.HttpRequest.newBuilder(java.net.URI.create(_url))
//                    .POST(java.net.http.HttpRequest.BodyPublishers.ofString(_json_query))
//                    .headers("accept", "application/json",
//                            "content-type", "application/json; charset=UTF-8",
//                            "x-ibm-client-id", _X_ibm_client_id,
//                            "x-ibm-client-secret", _X_ibm_client_secret)
//                    .timeout(time_out)
//                    .build();
//
//            java.util.concurrent.CompletableFuture<java.net.http.HttpResponse<java.io.InputStream>> response = client.sendAsync(request, java.net.http.HttpResponse.BodyHandlers.ofInputStream());
//            try {
//                // 'get' waits for result:
//                var is = response.get().body();
//                _result_as_pretty_JSON(is); // Versus '_result_as_raw_JSON(is);'
//            } catch (java.util.concurrent.ExecutionException | InterruptedException ee_ie) {
//                _json_query_result = javax.json.Json.createObjectBuilder().add(_ERROR, ee_ie.getMessage()).build().toString();
//                System.err.println(ee_ie.getClass().getSimpleName() + ": " + ee_ie.getMessage());
//            } finally {
//                _json_query_result_promise.complete(this);
//                _get_items_elapsed_time = System.currentTimeMillis() - _get_items_elapsed_time;
//            }
//        }
//    }
    private void _result_as_pretty_JSON(java.io.InputStream is) /*throws java.io.IOException*/ {
//        assert (is != null && is.available() == 0); // Official Java doc.: 'The available method for class InputStream always returns 0.'
        java.util.Map<String, Boolean> properties = new java.util.HashMap<>();
        properties.put(javax.json.stream.JsonGenerator.PRETTY_PRINTING, true);
        java.io.StringWriter sw = new java.io.StringWriter();
        try (javax.json.JsonWriter jw = javax.json.Json.createWriterFactory(properties).createWriter(sw)) {
            jw.writeObject(javax.json.Json.createReader(is).readObject());
            // 'close' is guaranteed by try-with-resource(s)
        } catch (javax.json.JsonException je) {
            // Input stream may be empty...         
            // Compensations occur in 'finally'
        } finally {
            _json_query_result = sw.toString(); // 'null' -> '""' when no result....
            _counted_items = 0L;
        }
        if (_json_query_result.length() > 0) {
            try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
                while (parser.hasNext()) {
                    // '_LIST' key is associated with a value being an array whose elements are the returned items (by default, only 20 are returned):
                    if (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME && parser.getString().equals(_LIST)) {
                        final javax.json.stream.JsonParser.Event event = parser.next();
                        assert (event == javax.json.stream.JsonParser.Event.START_ARRAY);
                        _counted_items = parser.getArray().size();
                    }
                }
            }
        }
    }

    private void _result_as_raw_JSON(java.io.InputStream is) /*throws java.io.IOException*/ {
//        assert (is != null && is.available() == 0); // Official Java doc.: 'The available method for class InputStream always returns 0.'
        /**
         * Taking advantage of Java 8, the 'lines' method allows the direct
         * access to a Java 8 stream, but only a *single* raw line of characters
         * is returned:
         */
        java.util.stream.Stream<String> raw_stream = new java.io.BufferedReader(new java.io.InputStreamReader(is)).lines(); // 'lines' method -> from Java 8 only!
        /**
         * For test only, stream is unusable afterwards:
         */
// assert (raw_stream.count() == 1);
// raw_stream.forEach(System.out::println);
        _json_query_result = raw_stream
                .map(string -> string.substring(string.indexOf(_LIST) + _LIST.length() + 1/*'"'*/ + 1/*':'*/, string.length() - 1/*'}'*/))
                .collect(java.util.stream.Collectors.joining()); // 'collect' applies reduction principle        
        _counted_items = 0L;
        if (_json_query_result.length() > 0) {
            try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
                while (parser.hasNext()) {
                    if (parser.next() == javax.json.stream.JsonParser.Event.START_ARRAY) {
                        _counted_items = parser.getArray().size();
                    }
                }
            }
        }
    }

    /**
     * 'check_format' adheres to 'Items 1.0.0' API. Any change in returned JSON
     * would probably make 'check_format' buggy
     */
    public void check_format() {
        try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
            while (parser.hasNext()) {
                // '_LIST' key is associated with a value being an array whose elements are the returned items (by default, only 20 are returned):
                if (parser.next() == javax.json.stream.JsonParser.Event.KEY_NAME && parser.getString().equals(_LIST)) {
                    final javax.json.stream.JsonParser.Event event = parser.next();
                    assert (event == javax.json.stream.JsonParser.Event.START_ARRAY);

                    java.util.stream.Stream<javax.json.JsonValue> stream = parser.getArrayStream();
// Check that all members are 'javax.json.JsonValue.ValueType.OBJECT':
//                    assert (stream
//                            .allMatch(json_value -> json_value.getValueType() == javax.json.JsonValue.ValueType.OBJECT));
// Next use of 'stream' fails because of this:                         
                    /**
                     * Great caution: a stream should be operated on (invoking
                     * an intermediate or terminal stream operation) only once.
                     * A stream implementation may throw 'IllegalStateException'
                     * if it detects that the stream is being reused.
                     */
// Check (based on map-reduce principle) that all members are 'javax.json.JsonValue.ValueType.OBJECT':
                    java.util.Optional<Boolean> optional = stream
                            .map(json_value -> json_value.getValueType() == javax.json.JsonValue.ValueType.OBJECT)
                            .reduce((Boolean a, Boolean b) -> a & b);
                    assert (optional.isPresent() && optional.get());
                }
            }
        }
    }

    private void _search_items_(javax.json.JsonObject carrefour_item_as_json_object, java.util.Set<String> words, java.util.concurrent.atomic.AtomicInteger strong, java.util.concurrent.atomic.AtomicInteger weak, String... gtins) {
        String gtin = gtins.length > 0 ? gtins[0] : carrefour_item_as_json_object.getString(_GTIN);
        for (javax.json.JsonValue json_value : carrefour_item_as_json_object.values()) {
            switch (json_value.getValueType()) {
                case OBJECT:
                    _search_items_((javax.json.JsonObject) json_value, words, strong, weak, gtin); // Recursive calls are around 4 * number of returned items...
                    break;
                case ARRAY:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include JSON array");
                case NUMBER:
                    /**
                     * For test only, be careful:
                     */
//                    assert (json_value.toString().equals(((javax.json.JsonNumber) json_value).toString()));
                    String[] data = _Word.split(json_value.toString());
                    for (String word : words) {
                        for (String sub_value : data) {
                            String sUB_VALUE = ToUpperCase(sub_value);
//                          String wORD = ToUpperCase(word); // Already done...
                            if (sUB_VALUE.contains(word)) {
                                weak.getAndIncrement();
                                if (sUB_VALUE.equals(word)) {
                                    strong.getAndIncrement();
                                }
                                try {
                                    _WebSocketServer.sendToken(_Handshaking.get(), com.seekdasky.websocket.Token.buildFromJSON(javax.json.Json.createObjectBuilder()
                                            .add(_GTIN, gtin)
                                            .add(_STRONG, strong.get())
                                            .add(_WEAK, weak.get())
                                            .add(_WORD, word)
                                            .build()));
                                } catch (java.util.concurrent.ExecutionException | InterruptedException | java.io.IOException ee_ie_ioe) {
                                    java.util.logging.Logger.getLogger(this.getClass().getSimpleName()).log(java.util.logging.Level.SEVERE, null, ee_ie_ioe);
                                }

                                break;
                            }
                        }
                    }
                    break;
                case STRING:
                    /**
                     * For test only, be careful:
                     */
//                    assert (!json_value.toString().equals(((javax.json.JsonString) json_value).getString()));
                    String[] data_ = _Word.split(((javax.json.JsonString) json_value).getString());
                    for (String word : words) {
                        for (String sub_value : data_) {
                            String sUB_VALUE = ToUpperCase(sub_value);
//                          String wORD = ToUpperCase(word); // Already done...
                            if (sUB_VALUE.contains(word)) {
                                weak.getAndIncrement();
                                if (sUB_VALUE.equals(word)) {
                                    strong.getAndIncrement();
                                }
//                                System.out.println("Sent to JavaScript: gtin: " + gtin + " strong: " + strong + " weak: " + weak + " sUB_VALUE: " + sUB_VALUE);
                                try {
                                    _WebSocketServer.sendToken(_Handshaking.get(), com.seekdasky.websocket.Token.buildFromJSON(javax.json.Json.createObjectBuilder()
                                            .add(_GTIN, gtin)
                                            .add(_STRONG, strong.get())
                                            .add(_WEAK, weak.get())
                                            .add(_WORD, word)
                                            .build()));
                                } catch (java.util.concurrent.ExecutionException | InterruptedException | java.io.IOException ee_ie_ioe) {
                                    java.util.logging.Logger.getLogger(this.getClass().getSimpleName()).log(java.util.logging.Level.SEVERE, null, ee_ie_ioe);
                                }
                                break;
                            }
                        }
                    }
                    break;
                case TRUE:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include 'true'");
                case FALSE:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include 'false'");
                case NULL:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include 'null'");
            }
        }
    }

    private void _search_items(javax.json.stream.JsonParser parser, java.util.Set<String> words) {
        while (parser.hasNext()) {
            final javax.json.stream.JsonParser.Event event = parser.next();
            switch (event) { // 'event' type in inferred so that 'KEY_NAME' is detected as value of the 'javax.json.stream.JsonParser.Event' enumerated type
                case KEY_NAME: // 'javax.json.stream.JsonParser.Event.KEY_NAME' creates a compilation error...
                    throw new RuntimeException(javax.json.stream.JsonParser.Event.KEY_NAME + " cannot be met due to parsing organization");
                case START_OBJECT:
                    java.util.concurrent.atomic.AtomicInteger strong = new java.util.concurrent.atomic.AtomicInteger(0),
                     weak = new java.util.concurrent.atomic.AtomicInteger(0);
                    _search_items_(parser.getObject(), words, strong, weak);
                    break;
                case END_OBJECT:
                    // Ok...
                    break;
                case START_ARRAY:
                    throw new RuntimeException(javax.json.stream.JsonParser.Event.START_ARRAY + " cannot be met due to parsing organization");
                case END_ARRAY:
                    // Ok... 'list' closing bracket -> once and for all!
                    break;
                case VALUE_NUMBER:
                    throw new RuntimeException(javax.json.stream.JsonParser.Event.VALUE_NUMBER + " cannot be met due to parsing organization");
                case VALUE_STRING:
                    throw new RuntimeException(javax.json.stream.JsonParser.Event.VALUE_STRING + " cannot be met due to parsing organization");
                case VALUE_TRUE:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include 'true'");
                case VALUE_FALSE:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include 'false'");
                case VALUE_NULL:
                    throw new RuntimeException(_LIST + " content ('Items 1.0.0' API) does not include 'null'");
            }
        }
    }

    private java.util.Set<String> _prepare_filtering(String... filters) {
        java.util.Set<String> words = new java.util.HashSet<>();
        for (String filter : filters) {
            java.util.Collections.addAll(words, _Word.split(ToUpperCase(filter)));
        }
        return words;
    }

    /**
     * 'filter_items' adheres to 'Items 1.0.0' API. Any change in returned JSON
     * would probably make 'filter_items' buggy
     */
    public void filter_items(String... filters) {
        _filter_items_elapsed_time = System.currentTimeMillis();
        java.util.Set<String> words = _prepare_filtering(filters);
        if (!words.isEmpty()) {
            try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
                while (parser.hasNext()) {
                    final javax.json.stream.JsonParser.Event next = parser.next();
                    if (next == javax.json.stream.JsonParser.Event.KEY_NAME) {
                        if (parser.getString().equals(_ERROR)) {
                            _filter_items_elapsed_time = -1L; // Error
                            break;
                        }
//                    else {
//                        assert (parser.getString().equals(_FOUND) || parser.getString().equals(_LIST));
//                    }
                    }
                    // '_LIST' key is associated with a value being an array whose elements are the returned items (by default, only 20 are returned):
                    if (next == javax.json.stream.JsonParser.Event.START_ARRAY) {
                        _search_items(parser, words);
                        _filter_items_elapsed_time = System.currentTimeMillis() - _filter_items_elapsed_time;
                        break; // Useless because parser is close to end through '_search_items'...
                    }
                }
                // 'close' is guaranteed by try-with-resource(s)
            }
        } else {
            _filter_items_elapsed_time = System.currentTimeMillis() - _filter_items_elapsed_time;
        }
    }

    /**
     * 'filter_items_' adheres to 'Items 1.0.0' API. Any change in returned JSON
     * would probably make 'filter_items_' buggy
     */
    public void filter_items_(boolean parallel, String... filters) {
        _filter_items_elapsed_time = System.currentTimeMillis();
        java.util.Set<String> words = _prepare_filtering(filters);
        if (!words.isEmpty()) {
            try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
                while (parser.hasNext()) {
                    final javax.json.stream.JsonParser.Event next = parser.next();
                    if (next == javax.json.stream.JsonParser.Event.KEY_NAME) {
                        if (parser.getString().equals(_ERROR)) {
                            _filter_items_elapsed_time = -1L; // Error
                            break;
                        } else {
//                        assert (parser.getString().equals(_FOUND) || parser.getString().equals(_LIST));
                        }
                    }
                    // '_LIST' key is associated with a value being an array whose elements are the returned items (by default, only 20 are returned):
                    if (next == javax.json.stream.JsonParser.Event.START_ARRAY) {
                        java.util.stream.Stream<javax.json.JsonValue> stream = parallel ? parser.getArrayStream().parallel() : parser.getArrayStream();
                        //   assert (stream.isParallel() || !parallel);
                        stream
                                // '(javax.json.JsonObject) json_value' <=> 'json_value.asJsonObject()':
                                .map(json_value -> (javax.json.JsonObject) json_value) // Be sure that array elements are actually JSON objects!
                                .forEach(new java.util.function.Consumer<javax.json.JsonObject>() {
                                    @Override
                                    public void accept(javax.json.JsonObject json_object) {
                                        java.util.concurrent.atomic.AtomicInteger strong = new java.util.concurrent.atomic.AtomicInteger(0), weak = new java.util.concurrent.atomic.AtomicInteger(0);
                                        _search_items_(json_object, words, strong, weak);
                                    }
                                });
//                    stream
//                            // Safer, but this excludes the possibility of checking that *all* members are *indeed* JSON objects:
//                            .filter(json_value -> json_value.getValueType() == javax.json.JsonValue.ValueType.OBJECT)
//                            // 'peek' is devoted to debugging (https://docs.oracle.com/javase/8/docs/api/java/util/stream/Stream.html#peek-java.util.function.Consumer-)
//                            .peek(json_value -> System.out.println("Filtered value: " + json_value.asJsonObject().toString()))
//                            .forEach(new java.util.function.Consumer<javax.json.JsonValue>() {
//                                @Override
//                                public void accept(javax.json.JsonValue json_value) {
//                                    _search_items_(json_value.asJsonObject(), words);
//                                }
//                            });
                        _filter_items_elapsed_time = System.currentTimeMillis() - _filter_items_elapsed_time;
                        break; // Useless: only one array (as value of '_LIST' key) exists in overall JSON
                    }
                }
            }
        } else {
            _filter_items_elapsed_time = System.currentTimeMillis() - _filter_items_elapsed_time;
        }
    }

    /**
     * 'filter_items__' adheres to 'Items 1.0.0' API. Any change in returned
     * JSON would probably make 'filter_items__' buggy
     */
    public void filter_items__(String... filters) {
        _filter_items_elapsed_time = System.currentTimeMillis();
        java.util.Set<String> words = _prepare_filtering(filters);
        if (!words.isEmpty()) {
            try (javax.json.stream.JsonParser parser = javax.json.Json.createParser(new java.io.StringReader(_json_query_result))) {
                while (parser.hasNext()) {
                    final javax.json.stream.JsonParser.Event next = parser.next();
                    if (next == javax.json.stream.JsonParser.Event.KEY_NAME) {
                        if (parser.getString().equals(_ERROR)) {
                            _filter_items_elapsed_time = -1L; // Error
                            break;
                        } else {
//                        assert (parser.getString().equals(_FOUND) || parser.getString().equals(_LIST));
                        }
                    }
                    // '_LIST' key is associated with a value being an array whose elements are the returned items (by default, only 20 are returned):
                    if (next == javax.json.stream.JsonParser.Event.START_ARRAY) {
                        // https://jaxenter.com/java-performance-tutorial-how-fast-are-the-java-8-streams-118830.html
//                    java.util.Set<javax.json.JsonObject> set = parser.getArrayStream()
//                            .map(json_value -> json_value.asJsonObject())
//                            .collect(java.util.stream.Collectors.toSet());
//                    java.util.Spliterator<javax.json.JsonObject> root_split_iterator = set.spliterator();
// ORDERED(0x00000010), DISTINCT(0x00000001), SORTED(0x00000004), SIZED(0x00000040), NONNULL(0x00000100), IMMUTABLE(0x00000400), CONCURRENT(0x00001000), SUBSIZED(0x00004000)
                        /**
                         * For test only, 'root_split_iterator' is obtained from
                         * 'Set' collection:
                         */
//                    assert (root_split_iterator.hasCharacteristics(java.util.Spliterator.DISTINCT));
//                    assert (root_split_iterator.characteristics() == (java.util.Spliterator.DISTINCT | java.util.Spliterator.SIZED));
                        java.util.List<javax.json.JsonObject> list = parser.getArrayStream()
                                .map(json_value -> json_value.asJsonObject())
                                .collect(java.util.stream.Collectors.toList()); // Reduction principle
                        java.util.Spliterator<javax.json.JsonObject> root_split_iterator = list.spliterator();
                        /**
                         * For test only, 'root_split_iterator' is obtained from
                         * 'List' collection:
                         */
//                    assert (root_split_iterator.characteristics() == (java.util.Spliterator.ORDERED | java.util.Spliterator.SIZED | java.util.Spliterator.SUBSIZED));
// Alternative:   
//                    java.util.Spliterator<javax.json.JsonObject> root_split_iterator = java.util.Spliterators.spliterator(list, (java.util.Spliterator.IMMUTABLE | java.util.Spliterator.NONNULL | java.util.Spliterator.ORDERED | java.util.Spliterator.SIZED | java.util.Spliterator.SUBSIZED));

                        java.util.Set<java.util.Spliterator<javax.json.JsonObject>> split_iterators = new java.util.HashSet<>();
                        _max_splitting(split_iterators, root_split_iterator); // Versus '_min_splitting(split_iterators, root_split_iterator);'
                        split_iterators.forEach((split_iterator) -> {
                            java.util.concurrent.atomic.AtomicInteger strong = new java.util.concurrent.atomic.AtomicInteger(0), weak = new java.util.concurrent.atomic.AtomicInteger(0);
                            split_iterator.forEachRemaining(json_object -> _search_items_(json_object, words, strong, weak));
// Alternative:                        
//                        boolean result;
//                        do {
//                            result = split_iterator.tryAdvance(json_object -> _search_items_(json_object, words));
//                        } while (result);
                        });
                        break; // Useless: only one array (as value of '_LIST' key) exists in overall JSON
                    }
                }
                _filter_items_elapsed_time = System.currentTimeMillis() - _filter_items_elapsed_time;
            }
        } else {
            _filter_items_elapsed_time = System.currentTimeMillis() - _filter_items_elapsed_time;
        }
    }

    private void _max_splitting(java.util.Set<java.util.Spliterator<javax.json.JsonObject>> split_iterators, java.util.Spliterator<javax.json.JsonObject> split_iterator) {
        /**
         * For test only:
         */
//        long split_iterator_estimateSize = split_iterator.estimateSize();
        java.util.Spliterator<javax.json.JsonObject> splitting = split_iterator.trySplit();
        if (splitting == null) {
            split_iterators.add(split_iterator);
        } else {
//            assert (split_iterator_estimateSize >= split_iterator.estimateSize() + splitting.estimateSize());
            _max_splitting(split_iterators, split_iterator);
            _max_splitting(split_iterators, splitting);
        }
    }

    private void _min_splitting(java.util.Set<java.util.Spliterator<javax.json.JsonObject>> split_iterators, java.util.Spliterator<javax.json.JsonObject> split_iterator) {
        java.util.Spliterator<javax.json.JsonObject> splitting = split_iterator.trySplit();
        if (splitting == null) {
            split_iterators.add(split_iterator);
        } else {
            split_iterators.add(split_iterator);
            split_iterators.add(splitting);
        }
    }

    public static void main(String[] args) {
//        System.out.println(_ToUpperCase("éàç")); // '"EAC"'

//
//        ci.check_format();
//        long average = 0L;
//        int times = 2;
//        for (int i = 0; i < times; i++) {
//            ci.filter_items(filter); // Change method here...
//            if (i != 0) {
//                average += ci._filter_items_elapsed_time;
//            }
//        }
//        System.out.println(average / (times - 1) + " ms for filtering from " + '"' + filter + '"');
    }
}
