package com.FranckBarbier.Java.Carrefour_Items;

public class Carrefour_Items_Query_Samples {

    /**
     * Query samples
     */
    /*    
    * Full-text search
     */
// Around 1.545.100 (query on 'description' *AND* 'brand'):
    final static String _All = "{\"size\":100,\"queries\": [{\"field\": \"barcodeDescription\",\"query\": \"\"}]}";
// Around 380 (query on 'description' only):
    final static String _ARIEL_description = "{\"queries\": [{\"query\": \"ariel\",\"field\": \"itemDescription\"}]}";
// Around 360 (query on 'brand' only):
    final static String _ARIEL_brand = "{\"queries\": [{\"query\": \"ariel\",\"field\": \"brandDescription\"}]}";
// Around 1.100 (query on 'description' *AND* 'brand'):
    final static String _ARI = "{\"size\": 2000,\"queries\": [{\"query\": \"ARI\",\"field\": \"barcodeDescription\"}]}";

// Around 85 items:
    final static String _NUTELLA = "{\"queries\": [{\"query\": \"nutella\",\"field\": \"barcodeDescription\"}]}";
    /*    
    * End of full-text search
     */

 /*    
    * Filtered search (*breakfast*)
     */
// Around 25 items (query with server-side filter):
    final static String _NUTELL = "{\"filters\": [{\"keys\": [\"140\"],\"field\": \"structHyp.hypGrpClassKey\"}],\"queries\": [{\"query\": \"nutell\",\"field\": \"barcodeDescription\"}]}";
    /*    
    * End of filtered search (*breakfast*)
     */

// Around 20.000 items (chocolate *OR* DVD 'Amélie Poulain' movie!):
    final static String _POU = "{\"size\": 10000,\"queries\": [{\"query\": \"pou\",\"field\": \"barcodeDescription\"}]}";
    final static String _POU_ = "{\"page\": 5,\"size\": 1000,\"queries\": [{\"query\": \"pou\",\"fields\": [\"itemDesc\",\"brandDesc\"]}]}";

// Around 100 items (chocolate *OR* DVD 'Amélie Poulain' movie!):
    final static String _POULAIN = "{\"size\": 200,\"queries\": [{\"query\": \"poulain\",\"field\": \"barcodeDescription\"}]}";
// Around 6 items:
    final static String _Raw_POULA_NOISET = "poula noiset";
    final static String _JSON_POULA_NOISET = "{\"queries\": [{\"query\": \"poula\",\"field\": \"barcodeDescription\"},{\"query\": \"noiset\",\"field\": \"barcodeDescription\"}]}";
// Non-string fields cannot be filtered yet:
// Don't working -> final static String _JSON_POULA_NOISET = "{\"filters\": [{\"keys\": [\"1\"],\"field\": \"prdCapaFactor\"}],\"queries\": [{\"query\": \"poula\",\"field\": \"barcodeDescription\"},{\"query\": \"noiset\",\"field\": \"barcodeDescription\"}]}";
// If filter is equal to "Lait LAIT NOISETTE 475" then (for '_POULA_NOISET'):
//    NOISETTE => [7622210290373, 7622210230041] // 'gtin' codes
//    475 => [3664346303842] // 'gtin' codes
//    LAIT => [3664346303842, 3664346300155] // 'gtin' codes
//    Lait => [3664346303842, 3664346300155] // 'gtin' codes (search is not case-sensitive!)
}
